<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template match="/">
		<xsl:comment>
This file was generated automatically from a ribbon xml.
Do not edit this file, edit the original ribbon xml instead.
</xsl:comment>
      		<menu_structure>
			<xsl:apply-templates/>
		</menu_structure>
	</xsl:template>
	
	<xsl:template match="menu_category">
		<menu_category name="menu_bar">
			<menu_submenu name="file" name_ref="file">	
				<xsl:apply-templates select="ribbon_taskbar"/>
				<xsl:apply-templates select="ribbon_menu"/>
			</menu_submenu>
			<menu_submenu name="edit" name_ref="edit">	
				<xsl:for-each select="ribbon_task[@name='home']/ribbon_band/ribbon_action">
					<xsl:variable name="action" select="@action"/>
					<xsl:apply-templates select="self::node()[not(preceding::node()[@action = $action] or following::node()[@action = $action])]"/>
				</xsl:for-each>
			</menu_submenu>
			<xsl:apply-templates select="ribbon_task"/>
		</menu_category>
	</xsl:template>
	
	<xsl:template match="ribbon_menu">
		<xsl:apply-templates select="primary_entry|ribbon_contributor"/>
		<xsl:apply-templates select="footer_entry"/>
	</xsl:template>
	
	<xsl:template match="ribbon_taskbar">
		<xsl:apply-templates/>
	</xsl:template>
	
	<xsl:template match="separator">
		<menu_separator/>
	</xsl:template>
	
	<xsl:template match="ribbon_task[@name='home']"/>
	
	<xsl:template match="ribbon_task">
		<xsl:choose>
		<xsl:when test="count(*) > 1">
			<xsl:element name="menu_submenu">
				<xsl:copy-of select="@*"/>
				<xsl:attribute name="name_ref">ribbon.task.<xsl:value-of select="@name"/></xsl:attribute>
				<xsl:apply-templates/>
			</xsl:element>
		</xsl:when>
		<xsl:otherwise>
			<xsl:apply-templates/>
		</xsl:otherwise>	
		</xsl:choose>
	</xsl:template>

	<xsl:template match="ribbon_contributor[@menu_key]">
		<xsl:choose>
			<xsl:when test="@name_ref">
				<xsl:element name="menu_submenu">
					<xsl:copy-of select="@*"/>
				</xsl:element>
			</xsl:when>
			<xsl:otherwise>
				<xsl:element name="menu_category">
					<xsl:copy-of select="@*"/>
				</xsl:element>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template match="primary_entry|footer_entry|entry_group|ribbon_action|ribbon_band">
		<xsl:choose>
			<xsl:when test="@name and *">
				
				<xsl:choose>
				<xsl:when test="count(descendant-or-self::*) > 1">
					<xsl:element name="menu_submenu">
						<xsl:copy-of select="@*"/>
						<xsl:attribute name="name_ref">
						<xsl:choose>
							<xsl:when test="name()='ribbon_band'">ribbon.band.</xsl:when>
							<xsl:otherwise>ribbon.menu.group.</xsl:otherwise>
						</xsl:choose>
						<xsl:value-of select="@name"/>
						</xsl:attribute>
						<xsl:apply-templates/>
					</xsl:element>	
				</xsl:when>
				<xsl:otherwise>
					<xsl:apply-templates/>
				</xsl:otherwise>
				</xsl:choose>
				
			</xsl:when>
			<xsl:otherwise>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template name="accelerator">
		<xsl:if test="@accelerator">
			<xsl:variable name="accelerator" select="@accelerator"/>
			<xsl:if test="not(preceding::*[@accelerator = $accelerator and not(ancestor::ribbon_task/@name='home')])">
				<xsl:attribute name="accelerator"><xsl:value-of select="@accelerator"/></xsl:attribute>
			</xsl:if>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="*[@action]">
		<xsl:variable name="action" select="@action"/>
		<xsl:element name="menu_action">
			<xsl:attribute name="action"><xsl:value-of select="@action"/></xsl:attribute>
			<xsl:call-template name="accelerator"></xsl:call-template>
		</xsl:element>
		<xsl:apply-templates/>	
	</xsl:template> 
</xsl:stylesheet>